//
//  Detent.swift
//  SheetController
//
//  Created by Shadowfacts on 9/23/19.
//  Copyright © 2019 Shadowfacts. All rights reserved.
//

import UIKit

public enum Detent: Equatable {
    case top
    case middle
    case bottom
    case other(CGFloat)
}

extension Detent {
    func offset(in view: UIView) -> CGFloat {
        switch self {
        case .top:
            return max(view.safeAreaInsets.top, 50)
        case .middle:
            return view.bounds.midY
        case .bottom:
            return view.bounds.height - view.safeAreaInsets.bottom - 100//max(view.safeAreaInsets.bottom, 100)
        case let .other(value):
            return value
        }
    }
}
